#! /usr/local/bin/apl --script
⍝ ********************************************************************
⍝ Workspace to remove all apl package manager packages except apl-pkg
⍝ Copyright (C) 2020 Bill Daly

⍝ This program is free software: you can redistribute it and/or modify
⍝ it under the terms of the GNU General Public License as published by
⍝ the Free Software Foundation, either version 3 of the License, or
⍝ (at your option) any later version.

⍝ This program is distributed in the hope that it will be useful,
⍝ but WITHOUT ANY WARRANTY; without even the implied warranty of
⍝ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
⍝ GNU General Public License for more details.

⍝ You should have received a copy of the GNU General Public License
⍝ along with this program.  If not, see <http://www.gnu.org/licenses/>.

⍝ ********************************************************************

)copy 1 ancillary/pkg_manager_lib
)copy 5 FILE_IO

∇list←clpkg∆packages pkg_home
  ⍝ Function returns a list of package manager packages
  list←⊃(FIO∆read_directory pkg_home)[;5]
  list←(~list[;⍳7]∧.='apl-pkg')⌿list
∇

∇pkg_home clpkg∆dropPackage pkg;sink
  ⍝ Function remove the named package from apl package manager
  sink←FIO∆pipefrom 'rm -rf ',pkg_home,'/',pkg
∇

∇main;list;pkg_home
  pkg_home←aplpu∆pkgMgr∆home
  list←clpkg∆packages pkg_home
  (⊂pkg_home) clpkg∆dropPackage ¨ list
∇

⍝ main

⍝ )off
