#! /usr/local/bin/apl --script
⍝ ********************************************************************
⍝ script to install apl-library into the APL Package Manager
⍝ Copyright (C) 2019 Bill Daly

⍝ This program is free software: you can redistribute it and/or modify
⍝ it under the terms of the GNU General Public License as published by
⍝ the Free Software Foundation, either version 3 of the License, or
⍝ (at your option) any later version.

⍝ This program is distributed in the hope that it will be useful,
⍝ but WITHOUT ANY WARRANTY; without even the implied warranty of
⍝ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
⍝ GNU General Public License for more details.

⍝ You should have received a copy of the GNU General Public License
⍝ along with this program.  If not, see <http://www.gnu.org/licenses/>.

⍝ ********************************************************************

)copy 1 utl
)copy 5 FILE_IO
)copy 1 cfg
)copy 1 utf8

∇ home←ins∆library_home ;org_path
  ⍝ Function returns a path to apl-library.
  home← ¯1↓'/' utl∆split org_path←3⊃⎕arg
  →(0=⍴1⊃home)/full_path
  →(('.' = 1↑org_path)∧1=⍴home)/in_ancillary
  ⍝ Executed in $HOME
  home←('/' utl∆split 2⊃,⎕env 'HOME'),(⊂'wslib1'),¯1↓home
  →ed
in_ancillary:
  home←¯1↓ '/' utl∆split FIO∆getcwd
  →ed
full_path:
  home←¯1↓home
  →ed
ed:
  home←'/' utl∆join home
∇

∇home ← ins∆pkgMgr∆home;fname;config
  ⍝ Function returns the base directory of the APL Paackage Manager.
  fname←(2⊃,⎕env'HOME'),'/.apl-pkg'
  config←cfg∆parse_file fname
  home←(config lex∆lookup 'DEFAULT')lex∆lookup 'packages_directory'
∇

∇ins∆install;lib_home;pkg_home;cmd
  ⍝ Function to copy library files into apl package manager home.
  lib_home←ins∆library_home
  pkg_home←ins∆pkgMgr∆home
  cmd←ins∆library_home,'/ancillary/migrate2pkg.sh ',lib_home,' ',pkg_home
  ⍞←utf8∆sh cmd
∇

ins∆install

)off

