#! /usr/local/bin/apl --script
⍝ ********************************************************************
⍝ pkg_manager_lib A collection of pkg manager specific utilities
⍝ Copyright (C) 2020 Bill Daly

⍝ This program is free software: you can redistribute it and/or modify
⍝ it under the terms of the GNU General Public License as published by
⍝ the Free Software Foundation, either version 3 of the License, or
⍝ (at your option) any later version.

⍝ This program is distributed in the hope that it will be useful,
⍝ but WITHOUT ANY WARRANTY; without even the implied warranty of
⍝ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
⍝ GNU General Public License for more details.

⍝ You should have received a copy of the GNU General Public License
⍝ along with this program.  If not, see <http://www.gnu.org/licenses/>.

⍝ ********************************************************************

)copy 1 cfg
)copy 1 utl

∇home ← aplpu∆pkgMgr∆home;fname;config
  ⍝ Function returns the base directory of the APL Paackage Manager.
  fname←(2⊃,⎕env'HOME'),'/.apl-pkg'
  →(~aplpu∆file_exists fname)/noPkg
  config←cfg∆parse_file fname
  home←(config lex∆lookup 'DEFAULT')lex∆lookup 'packages_directory'
  →(~aplpu∆file_exists home)/noPkg
  →(~aplpu∆file_exists home,'/apl-pkg')/noPkg
  →0
noPkg:			⍝ APL Package Manager not installed.
  utl∆es 'Can not find APL Package Manager'
∇

∇ b←aplpu∆file_exists fname;h;sink
  ⍝ Function tests the existance of fname.
  h←'r' FIO∆fopen fname
  →(0>h)/no
yes:
  b←1
  sink←FIO∆fclose h
  →0
no:
  b←0
  →0
∇

