#! /usr/local/bin/apl --script
⍝ ********************************************************************
⍝ ex-im-test.apl Workspace to test export.apl and import.apl
⍝ Copyright (C) 2019 Bill Daly

⍝ This program is free software: you can redistribute it and/or modify
⍝ it under the terms of the GNU General Public License as published by
⍝ the Free Software Foundation, either version 3 of the License, or
⍝ (at your option) any later version.

⍝ This program is distributed in the hope that it will be useful,
⍝ but WITHOUT ANY WARRANTY; without even the implied warranty of
⍝ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
⍝ GNU General Public License for more details.

⍝ You should have received a copy of the GNU General Public License
⍝ along with this program.  If not, see <http://www.gnu.org/licenses/>.

⍝ ********************************************************************

)copy 1 import
)copy 1 export
)copy 1 prompt
)copy 1 assert
)copy 1 find_test_data

∇b←test∆exim∆fileExists fname;list;parsed
  ⍝ Function  to prove a file has been created.
  parsed←utl∆fileName∆parse fname
  list←utf8∆dir 1⊃parsed
  b←(1↑⍴list)≥list utl∆listSearch '.' utl∆join 1↓parsed
∇

∇rs←test∆exim∆fileRm fname;ph;txt
  ⍝ Function to remove files
  rs←⎕fio[19] fname
∇


∇test∆exim;test01;test02
  181 3 assert∆toScreen '⍴test01← import∆table import∆file test_data,''/example_tb.txt'''
  ⍞←'Test one read this table from example_tb.txt',⎕tc[3]
  ⍞←test01
  ⍞←⎕tc[3]
  'test∆exim∆fileExists ''/tmp/eximtest01.txt''' assert∆nil∆toScreen '(⊂[2]test01) export∆nested ''/tmp/eximtest01.txt'''
  569 18 assert∆toScreen '⍴test02← import∆table import∆file test_data,''/2019_DOE_mpg.csv'''
  ⍞←'Test three read this table from 2019_DOE_mpg.csv',⎕tc[3]
  ⍞←test02[⍳10;]
  ⍞←⎕tc[3]
  'test∆exim∆fileExists ''/tmp/eximtest02.txt''' assert∆nil∆toScreen '(⊂[2]test02) export∆nested ''/tmp/eximtest02.txt'''
  ⍞←'Test four import a file with dates in one field'
  ⍞←⎕tc[3]
  assert∆true assert∆toScreen 'utl∆numberp 1 1↓ date∆US import∆file∆withDates test_data,''/ABBV.csv'''
  ⎕dl 5
  assert∆cleanUp 'test∆exim∆fileRm ''/tmp/eximtest01.txt''' 'test∆exim∆fileRm ''/tmp/eximtest02.txt'''
∇

⍝)off
