#! /usr/local/bin/apl --script
⍝ ********************************************************************
⍝ fmt_test.apl Unit testing of fmt workspaces
⍝ Copyright (C) 2019 Bill Daly

⍝ This program is free software: you can redistribute it and/or modify
⍝ it under the terms of the GNU General Public License as published by
⍝ the Free Software Foundation, either version 3 of the License, or
⍝ (at your option) any later version.

⍝ This program is distributed in the hope that it will be useful,
⍝ but WITHOUT ANY WARRANTY; without even the implied warranty of
⍝ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
⍝ GNU General Public License for more details.

⍝ You should have received a copy of the GNU General Public License
⍝ along with this program.  If not, see <http://www.gnu.org/licenses/>.

⍝ ********************************************************************

)copy 1 fmt
)copy 1 assert
)copy 1 import
)copy 1 find_test_data

∇test∆fmt
  assert∆setup 'test∆fmt∆inv←import∆file test_data,''/inv.txt'''
  ⍝
  test∆fmt∆ft01←'N⍞ Cr⍞Q⍞ Dr⍞F14.2'

  '    1234.00 Dr' assert∆toScreen 'test∆fmt∆ft01 fmt 1234'
  '    1234.00 Cr' assert∆toScreen 'test∆fmt∆ft01 fmt ¯1234'
  '       0.00 Dr' assert∆toScreen 'test∆fmt∆ft01 fmt 0'
  '**************' assert∆toScreen 'test∆fmt∆ft01 fmt 1.5E9'
  ⍝
  test∆fmt∆ft02←'N⍞ Cr⍞Q⍞ Dr⍞CF14.2'
  '   1,234.00 Dr' assert∆toScreen 'test∆fmt∆ft02 fmt 1234'
  '   1,234.00 Cr' assert∆toScreen 'test∆fmt∆ft02 fmt ¯1234'
  ⍝
  test∆fmt∆ft03←'M⍞(⍞N⍞)⍞F10.3'
  ⍝
  ' 1234.000 ' assert∆toScreen 'test∆fmt∆ft03 fmt 1234'
  '(1234.000)' assert∆toScreen 'test∆fmt∆ft03 fmt ¯1234'
  ⍝
  test∆fmt∆ft04←'M⍞(⍞N⍞)⍞CF10.3'
  ⍝
  '1,234.000 ' assert∆toScreen 'test∆fmt∆ft04 fmt 1234'
  '**********' assert∆toScreen 'test∆fmt∆ft04 fmt ¯1234'
  ⍝
  test∆fmt∆int01←'N⍞ Cr⍞Q⍞ Dr⍞I12'
  ⍝
  '     1234 Dr' assert∆toScreen 'test∆fmt∆int01 fmt 1234'
  '     1234 Cr' assert∆toScreen 'test∆fmt∆int01 fmt ¯1234'
  ⍝
  test∆fmt∆int02←'N⍞ Cr⍞Q⍞ Dr⍞CI10'
  '  1,234 Dr' assert∆toScreen 'test∆fmt∆int02 fmt 1234'
  '  1,234 Cr' assert∆toScreen 'test∆fmt∆int02 fmt ¯1234'
  ⍝
  test∆fmt∆int03←'M⍞(⍞N⍞)⍞I10'
  '     1234 ' assert∆toScreen 'test∆fmt∆int03 fmt 1234'
  '    (1234)' assert∆toScreen 'test∆fmt∆int03 fmt ¯1234'
  ⍝

  test∆fmt∆int04←'M⍞(⍞N⍞)⍞CI10'
  '    1,234 ' assert∆toScreen 'test∆fmt∆int04 fmt 1234'
  '   (1,234)' assert∆toScreen 'test∆fmt∆int04 fmt ¯1234'
  ⍝ test test delimiters
  test∆fmt∆ft05←'N/ Cr/Q/ Dr/F14.2'
  '    1234.00 Dr' assert∆toScreen 'test∆fmt∆ft05 fmt 1234'
  '    1234.00 Cr' assert∆toScreen 'test∆fmt∆ft05 fmt ¯1234'
  ⍝
  '12345678.00 Dr' assert∆toScreen 'test∆fmt∆ft05 fmt 12345678'
  '12345678.00 Cr' assert∆toScreen 'test∆fmt∆ft05 fmt ¯12345678'
  ⍝
  test∆fmt∆ft06←'N/ Cr/Q/ Dr/CF14.2'

  '  12,345.00 Dr' assert∆toScreen 'test∆fmt∆ft06 fmt 12345'
  '  12,345.00 Cr' assert∆toScreen 'test∆fmt∆ft06 fmt ¯12345'
  ⍝
  test∆fmt∆ft07←'M/(/N/)/F10.3'
  ' 1234.000 ' assert∆toScreen 'test∆fmt∆ft07 fmt 1234'
  '(1234.000)' assert∆toScreen 'test∆fmt∆ft07 fmt ¯1234'
  ⍝
  test∆fmt∆ft08←'M/(/N/)/CF13.3'
  ' 123,456.000 ' assert∆toScreen 'test∆fmt∆ft08 fmt 123456'
  '(123,456.000)' assert∆toScreen 'test∆fmt∆ft08 fmt ¯123456'
  ⍝ test scaling of output
  test∆fmt∆ft11←'M/(/N/)%/Q/%/K2F14.2'
  '       12.35% ' assert∆toScreen 'test∆fmt∆ft11 fmt .123456'
  '      (12.35)%' assert∆toScreen 'test∆fmt∆ft11 fmt ¯.123456'
  ⍝
  test∆fmt∆ft12←'M/(/N/)%/Q/%/CK2F14.2'
  '       12.35% ' assert∆toScreen 'test∆fmt∆ft12 fmt .123456'
  '      (12.35)%' assert∆toScreen 'test∆fmt∆ft12 fmt ¯.123456'
  ⍝
  test∆fmt∆tz←'ZM/(/N/)/CF14.2'
  '0000001234.00 ' assert∆toScreen 'test∆fmt∆tz fmt 1234'
  '(000001234.00)' assert∆toScreen 'test∆fmt∆tz fmt ¯1234'
  ⍝
  test∆fmt∆te01←'M/(/N/)/E10.4'
  '  1.234E3 ' assert∆toScreen 'test∆fmt∆te01 fmt 1234'
  ' (1.234E3)' assert∆toScreen 'test∆fmt∆te01 fmt ¯1234'
  '  1.000E0 ' assert∆toScreen 'test∆fmt∆te01 fmt 1'
  '  0.000E0 ' assert∆toScreen 'test∆fmt∆te01 fmt 0'
  ⍝
  test∆fmt∆te02←'M/-/E6.4'
  '******' assert∆toScreen 'test∆fmt∆te02 fmt 12345'
  ⍝
  test∆fmt∆tb01←'BCM<(>N<)>F14.2'
  (14⍴' ') assert∆toScreen 'test∆fmt∆tb01 fmt 0'
  '   (98,765.00)' assert∆toScreen 'test∆fmt∆tb01 fmt ¯98765'
  ⍝
  test∆fmt∆ti01←'P<To prove Info assertion >F35.2,F9.2'

  '   To prove Info assertion 10100.00999750.00'assert∆toScreen 'test∆fmt∆ti01 fmt 10100 999750'
  ⍝
  ⍞←'Formating a nested array: ',⎕tc[3]
  'A5,A25,K2Q⍞%⍞F7.2,M⍞(⍞N⍞)⍞CF14.2' fmt 1 0↓test∆fmt∆inv[;1 2 5 11]
  ⍝
  ⍞←⎕tc[3],'Formating a simple array',⎕tc[3]
  '38A1,K2Q/%/F7.2,M/(/N/)/CF14.2' fmt 1 0↓((⊃test∆fmt∆inv[;1]),' ',⊃test∆fmt∆inv[;2]),test∆fmt∆inv[;5 11]
  ⍝
  ⍞←⎕tc[3],'Formating a simple array with repeating formats of numeric columns.',⎕tc[3]
  'A6,A25,3M/(/N/)/CF14.2' fmt 1 0↓test∆fmt∆inv[;1 2 11 12 13]
∇
