#! /usr/local/bin/apl --script
 ⍝ ********************************************************************
 ⍝   $Id: $
 ⍝ $desc: Script to unit test library lex1 $
 ⍝ ********************************************************************
⍝ Copyright (C) 2016 Bill Daly

⍝ This program is free software: you can redistribute it and/or modify
⍝ it under the terms of the GNU General Public License as published by
⍝ the Free Software Foundation, either version 3 of the License, or
⍝ (at your option) any later version.

⍝ This program is distributed in the hope that it will be useful,
⍝ but WITHOUT ANY WARRANTY; without even the implied warranty of
⍝ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
⍝ GNU General Public License for more details.

⍝ You should have received a copy of the GNU General Public License
⍝ along with this program.  If not, see <http://www.gnu.org/licenses/>.



)copy 1 lex1
)copy 1 assert
)copy 1 import
)copy 1 find_test_data

∇key←test∆lex1∆key ln;tmp
  ⍝ Function to create a key of lastname,FirstInitial
  key←(⊃ln[1]),1↑⊃ln[2]
∇

∇h1←h test∆lex1∆assign array;k;l;i;labels
  ⍝ Function for assigning leads to a hashed lexicon
  labels←((1↑⍴array)⍴start),end
  i←1
  h1←h
start:
  k←⊂(⊃array[i;1]),1↑⊃array[i;2]
  l←⊂( array[i;])
  h1← h1 lex1∆assign k,l
  →labels[i←i+1]
end:
  →0
∇

∇test∆lex1
  1 assert∆toScreen 'lex1∆is test∆lex1∆leads← lex1∆init 97'
  assert∆setup 'test∆lex1∆leads←test∆lex1∆leads test∆lex1∆assign import∆file test_data,''/leads.txt'''
  assert∆message 'Display the distribtuion of items to the buckets in txt∆lex1∆leads:'
  assert∆setup '⍞←(lex1∆distribution test∆lex1∆leads),⎕tc[3]'
  assert∆message 'Lookup the values of various keys',⎕av[11]
  'Demiri' 'Valerie' '928 Jaymor Road Suite B-150' 'Philadelphia' 'PA' assert∆toScreen 'test∆lex1∆leads lex1∆lookup ''DemiriV'''
  'Kinslow' 'Tracey' '1069 Jacksonville Road' 'Langhorne' 'PA' assert∆toScreen 'test∆lex1∆leads lex1∆lookup ''KinslowT'''
  'Stewart' 'Steven' '9150 Marshall Street No 9' 'Philadelphia' 'PA' assert∆toScreen 'test∆lex1∆leads lex1∆lookup ''StewartS'''
  'Dellavella' 'Vladimir' '1850 Byberry Road' 'Levittown' 'PA' assert∆toScreen 'test∆lex1∆leads lex1∆lookup ''DellavellaV'''
  (1↑⍴lex1∆keys test∆lex1∆leads) assert∆toScreen '⍴lex1∆values test∆lex1∆leads'
∇

⍝)off
