#! /usr/local/bin/apl --script
⍝ ********************************************************************
⍝   $Id: $
⍝ $desc: Script to test the stat database. $
⍝ ********************************************************************
⍝ Copyright (C) 2018 Bill Daly

⍝ This program is free software: you can redistribute it and/or modify
⍝ it under the terms of the GNU General Public License as published by
⍝ the Free Software Foundation, either version 3 of the License, or
⍝ (at your option) any later version.

⍝ This program is distributed in the hope that it will be useful,
⍝ but WITHOUT ANY WARRANTY; without even the implied warranty of
⍝ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
⍝ GNU General Public License for more details.

⍝ You should have received a copy of the GNU General Public License
⍝ along with this program.  If not, see <http://www.gnu.org/licenses/>.
)copy 1 stat
)copy 1 assert
)copy 1 import
)copy 1 find_test_data


 ∇ test∆stat ;test∆stat∆mpg;abbv;sink
  'Loading EPA mpg by manufacturer and model for year 2019',2⍴⎕tc[3]
  test∆stat∆mpg←import∆table import∆file test_data,'/2019_DOE_mpg.csv'
  ⍝ Assertions checked against results in R -- wld 10/13/2019
  ⍝
  20.65 assert∆toScreen '¯2 utl∆round stat∆mean 1↓test∆stat∆mpg[;10]'
  ⍝
  20 assert∆toScreen 'stat∆median 2↓test∆stat∆mpg[;10]' ⍝ Even number of observations
  ⍝
  20 assert∆toScreen 'stat∆median 1↓test∆stat∆mpg[;10]' ⍝ Odd number of observations
  ⍝
  4.9122 assert∆toScreen '¯4 utl∆round stat∆sampleSD 1↓test∆stat∆mpg[;10]'
  ⍝
  assert∆setup 'abbv←date∆US import∆file∆withDates test_data,''/ABBV.csv'''
  0.6693 assert∆toScreen '¯4 utl∆round stat∆timeSeries∆slope 1↓abbv[;6]'
  46.8004 assert∆toScreen '¯4 utl∆round 0.6692792286 stat∆timeSeries∆intercept 1↓abbv[;6]'
  0.7374 assert∆toScreen '¯4 utl∆round stat∆timeSeries∆cor 1↓abbv[;6]'
  
∇
⍝)off

