#! /usr/local/bin/apl --script
⍝ ********************************************************************
⍝   $Id: $
⍝ $desc: Script to test util workspaces $
⍝ ********************************************************************

⍝ Copyright (C) 2016 Bill Daly 

⍝ This program is free software: you can redistribute it and/or modify
⍝ it under the terms of the GNU General Public License as published by
⍝ the Free Software Foundation, either version 3 of the License, or
⍝ (at your option) any later version.

⍝ This program is distributed in the hope that it will be useful,
⍝ but WITHOUT ANY WARRANTY; without even the implied warranty of
⍝ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
⍝ GNU General Public License for more details.

⍝ You should have received a copy of the GNU General Public License
⍝ along with this program.  If not, see <http://www.gnu.org/licenses/>.

)copy 1 utl
)copy 1 assert
)copy 1 import
)copy 1 find_test_data

∇ test∆utl;list;ix;lb;iy
  ⍝ Master utl test function;
  list←⎕nl 3
  list←(list[;⍳8]∧.='test∆utl')⌿list
  ix←list utl∆listSearch  'test∆utl'
  list←(~(⍳1↑⍴list)∊ix)⌿list
  iy←1
  lb←((1↑⍴list)⍴st),ed
st:
  ⍎list[iy;]
  →lb[iy←iy+1]
ed:
  →0
∇

⍝ ∇b←test∆utl∆helpfns
⍝   ⍝ Function created to test utl∆helpFns
⍝   b←1                                   
⍝   ⍝ Comment to be ignored               
⍝ ∇

⍝ ∇test∆utl∆help
⍝   (⊃'b←test∆utl∆helpfns' '⍝ Function created to test utl∆helpFns') assert∆toScreen 'utl∆helpFns ''test∆utl∆helpfns'''
⍝ ∇

∇test∆utl∆numberp
  assert∆true assert∆toScreen 'utl∆numberp ?100'
  assert∆true assert∆toScreen 'utl∆numberp 5?100'
  assert∆false assert∆toScreen 'utl∆numberp ''Test string'''
  assert∆false assert∆toScreen 'utl∆numberp '''''
∇

∇test∆utl∆strpArraySpaces
  'A string' assert∆toScreen 'utl∆stripArraySpaces ''   A string        '''
  (3 10⍴'Line one  Line two  Line three') assert∆toScreen 'utl∆stripArraySpaces ⊃''   Line one    '' ''  Line two'' ''Line three    '''
∇
∇test∆utl∆split
  'one' 'two' 'three' 'four' 'five' assert∆toScreen '''/'' utl∆split ''one/two/three/four/five''',⎕av[11]
∇

∇test∆utl∆split2
  'one' 'two' 'three' 'four' 'five' assert∆toScreen '''/'' utl∆split2 ''one/two/three/four/five''',⎕av[11]
∇

∇test∆utl∆join
  'one/two/three/four' assert∆toScreen '''/'' utl∆join ''one'' ''two'' ''three'' ''four'''
∇

∇test∆utl∆import∆numbers
  45 ¯16738.8 187 0.006 10510 assert∆toScreen 'utl∆import∆numbers ''/'' utl∆split ''45/(16,738.80)/187/0.006/10,510'''
  ⍝
  45 ¯167 1887 ¯.06 5 assert∆toScreen 'utl∆import∆numbers ''/'' utl∆split ''45/-167/1887/-.06/5'''
∇

∇test∆utl∆convertStringToNumber
  100 assert∆toScreen 'utl∆convertStringToNumber ''  100  '''
  0 assert∆toScreen 'utl∆convertStringToNumber ''  -  '''
 ¯95 assert∆toScreen 'utl∆convertStringToNumber ''-95.00 '''
∇

∇test∆utl∆search;txt;rs
  txt←utf8∆read test_data,'/shakespeare.txt'
  35 61 assert∆toScreen 'txt utl∆search ''that'''
  (1⍴673) assert∆toScreen 'txt utl∆search ''And so'''
  ⍝
  rs←'And then receiv''d. Now, pious sir,'
  rs←rs,,(,⎕ucs 10),'You will demand of me why I do this?',,⎕ucs 10
  ⍝
  rs assert∆toScreen '(672↓txt) utl∆replace ''so'' ''then'''
∇

∇test∆utl∆case
  'AND THEN RECEIV''D' assert∆toScreen 'utl∆upper ''And then Receiv''''d'''
  'and then receiv''d' assert∆toScreen 'utl∆lower ''And then Receiv''''d'''
∇

∇test∆utl∆numberis
  assert∆true assert∆toScreen 'utl∆numberis ''45'''
  assert∆true assert∆toScreen 'utl∆numberis ''¯45'''
  assert∆false assert∆toScreen 'utl∆numberis ''4¯5'''
  assert∆true assert∆toScreen 'utl∆numberis ''45.'''
  assert∆false assert∆toScreen 'utl∆numberis ''4.5.'''
  assert∆true assert∆toScreen 'utl∆numberis ''  123.76 '''
  assert∆false assert∆toScreen 'utl∆numberis '' 123 76  '''
  assert∆false assert∆toScreen 'utl∆numberis ''Now is the winter of our discontent'''
∇

∇test∆utl∆execTime;tst
  assert∆true assert∆toScreen '0<100 utl∆execTime ''tst←utl∆upper ''''one'''''''
∇

∇test∆utl∆split_with_quotes
  '100' 'A string' '500' assert∆toScreen ''','' utl∆split_with_quotes ''100,"A string",500'''
∇

∇test∆utl∆clean;t1;t2
  t1←'A string of many Things including multiple spaces tabs and linefeeds.'
  t2←'	A string    of many Things including   ',⎕tc[3],'multiple spaces tabs and linefeeds.     '
  t1 assert∆toScreen 'utl∆clean t2'
∇

∇test∆utl∆stringEquals
  assert∆true assert∆toScreen '''A test string'' utl∆stringEquals ''A test string'''
  assert∆false assert∆toScreen '''Yet another test string'' utl∆stringEquals ''A test string'''
∇

∇test∆utl∆listSearch;t1
  t1←'/' utl∆split 'one/two/three/four/fifteen/sixty-five'
  4 assert∆toScreen 't1 utl∆listSearch ''four'''
  7 assert∆toScreen 't1 utl∆listSearch ''seven'''
∇

∇test∆utl∆today
  ('06/06/0000' ⍕ ⎕ts[2 3 1]) assert∆toScreen 'utl∆today'
∇

∇test∆utl∆stringp
  assert∆true assert∆toScreen 'utl∆stringp ''A string'''
  assert∆false assert∆toScreen 'utl∆stringp 16'
  assert∆false assert∆toScreen 'utl∆stringp 3 4⍴⍳12'
  assert∆false assert∆toScreen 'utl∆stringp ''A'' ''nested array'' ''of strings'''
∇

∇test∆utl∆round
  105 assert∆toScreen 'utl∆round 104.973'
  105 assert∆toScreen '¯1 utl∆round 104.973'
  104.97 assert∆toScreen '¯2 utl∆round 104.973'
  100 assert∆toScreen '1 utl∆round 104.973'
∇

∇test∆utl∆numberedArray;numbered
  assert∆setup 'numbered←(⊃''/'' utl∆split ''[001] one/[002] two/[003] fourteen/[004] seventeen/[005] random numbers'')'
  numbered assert∆toScreen 'utl∆numberedArray ⊃''one'' ''two'' ''fourteen'' ''seventeen'' ''random numbers'''
∇

∇test∆utl∆breakon;break_data
  assert∆setup 'break_data←import∆file test_data, ''/breakon_data.txt'''
  31703 9161 58845 assert∆toScreen 'break_data[;1] utl∆breakon break_data[;2]'
∇

∇test∆utl∆sort;sort_test;sort_result;path
  path←test_data,'/inv-fifthQ.txt'
  assert∆setup 'sort_test←import∆file path'
  sort_result← 'ABBV' 'CTL' 'CVX' 'DUK' 'EPD' 'GE' 'GIS' 'GM' 'IBM' 'IEP' 'INTL' 'IP' 'KHC' 'MET' 'MO' 'NWL' 'PAGP' 'PM' 'PRU' 'QCOM' 'SO' 'TRV' 'VLO' 'VZ' 'WDC' 'WRK' 'XONA.F'
  sort_result assert∆toScreen 'utl∆sort 1↓sort_test[;1]'
∇

∇test∆utl∆quad;path;quad_test;rows;cols
  path←test_data,'/inv_f500.txt'
  assert∆setup 'quad_test←import∆file path'
  rows←1 2 3
  cols←2 3 4
  (rows cols) assert∆toScreen 'quad_test utl∆quad ⍳4'
∇

∇test∆utl∆stringMember;list
  assert∆setup 'list←''one'' ''two'' ''four'' ''five'' ''six'' ''eighteen'''
  assert∆true assert∆toScreen '''four'' utl∆stringMember list'
  assert∆false assert∆toScreen '''nine'' utl∆stringMember list'
∇

∇test∆utl∆bifurcate
  '2019' '32' assert∆toScreen '''W'' utl∆bifurcate ''2019W32'''
  '2019W32' assert∆toScreen '''T'' utl∆bifurcate ''2019W32'''
∇

⍝)off
