#! /usr/local/bin/apl --script
⍝ Script to run test on the finance workspace
⍝ Copyright (C) 2018 Bill Daly

⍝ This program is free software: you can redistribute it and/or modify
⍝ it under the terms of the GNU General Public License as published by
⍝ the Free Software Foundation, either version 3 of the License, or
⍝ (at your option) any later version.

⍝ This program is distributed in the hope that it will be useful,
⍝ but WITHOUT ANY WARRANTY; without even the implied warranty of
⍝ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
⍝ GNU General Public License for more details.

⍝ You should have received a copy of the GNU General Public License
⍝ along with this program.  If not, see <http://www.gnu.org/licenses/>.
)copy 1 finance
)copy 1 utl
)copy 1 assert

∇test∆finance;cmd;table;t1
  13700 assert∆toScreen '1 utl∆round fin∆compoundValue 10000 .065 5'
  10000 assert∆toScreen '1 utl∆round fin∆presentValue 13701 .065 5'
  10000 assert∆toScreen '1 utl∆round fin∆netPresentValue .065,(4⍴0),13701'
  3590 assert∆toScreen '1 utl∆round fin∆compoundAnnuity 250 .065 10'
  1800 assert∆toScreen '1 utl∆round fin∆presentValueAnnuity 250 .065 10'
  250 assert∆toScreen '0 utl∆round fin∆annuityPayment 1800 .065 10'
  3420 assert∆toScreen '1 utl∆round fin∆netPresentValue .045 ¯123400 36200 54800 48100'
  ¯2750 assert∆toScreen '1 utl∆round fin∆netPresentValue .065 ¯10000 1000 1200 ¯5000 1500 1600 2000 1800 1700 1500 1450 1400 1200 1000'
  0.02385 assert∆toScreen '¯5 utl∆round fin∆irr .065 ¯10000 1000 1200 ¯5000 1500 1600 2000 1800 1700 1500 1450 1400 1200 1000'
  0.05962 assert∆toScreen '¯5 utl∆round fin∆irr .065 ¯123400 36200 54800 48100'
  ⍝ Test dateflow
  cmd←⊂'t1←fin∆df∆init (date∆lillian 2020 01 31),¯5000'
  cmd←cmd,⊂'t1←t1 fin∆df∆add (date∆lillian 2020 04 30), 100'
  cmd←cmd,⊂'t1←t1 fin∆df∆add (date∆lillian 2020 07 31), 100'
  cmd←cmd,⊂'t1←t1 fin∆df∆add (date∆lillian 2020 10 31), 100'
  cmd←cmd,⊂'t1←t1 fin∆df∆add (date∆lillian 2021 1 31), 100'
  cmd←cmd,⊂'t1←t1 fin∆df∆add (date∆lillian 2021 2 15),4995'
  assert∆setup cmd
  0.0751 assert∆toScreen '¯4 utl∆round fin∆df∆irr t1 .1'
  table←'2020/01/31' 0 5000 5000
  table←table,[.1]'2020/04/30' 93.49  ¯100 4993.49 
  table←table,[1]'2020/07/31' 95.46  ¯100 4988.95 
  table←table,[1]'2020/10/31' 95.37  ¯100 4984.32 
  table←table,[1]'2021/01/31' 95.28  ¯100 4979.6  
  table←table,[1]'2021/02/15' 15.4  ¯4995    0    

  table assert∆toScreen 'fin∆df∆amortizationTable t1 0.07513550269'
  ¯124.1111 assert∆toScreen '¯4 utl∆round fin∆df∆net_pv t1 .1'
∇
⍝)off
