#! /usr/local/bin/apl --script
⍝ ********************************************************************
⍝ lpr_test.apl: Pkg manager test of lpr workspaces
⍝ Copyright (C) 2019 Bill Daly

⍝ This program is free software: you can redistribute it and/or modify
⍝ it under the terms of the GNU General Public License as published by
⍝ the Free Software Foundation, either version 3 of the License, or
⍝ (at your option) any later version.

⍝ This program is distributed in the hope that it will be useful,
⍝ but WITHOUT ANY WARRANTY; without even the implied warranty of
⍝ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
⍝ GNU General Public License for more details.

⍝ You should have received a copy of the GNU General Public License
⍝ along with this program.  If not, see <http://www.gnu.org/licenses/>.

⍝ ********************************************************************

)copy 1 lpr
)copy 1 prompt
)copy 1 utf8
)copy 1 find_test_data

∇ test∆lpr;txt;html;ans
  ⍝ Function to test lpr workspace
  →(2=⎕nc 'test∆printer')/first
  ans←prompt 'What is the name (that cups understands) of your printer? '
  →(utl∆numberp ans)/nop
  test∆printer←lpr∆USLetter ans
first:
  txt←utf8∆read test_data,'/shakespeare.txt'
  →(utl∆numberp ans←prompt 'This test will print a sample of shaespeare.  Type OK <enter> for report ')/next
  →(~∧/'OK'=utl∆upper 2↑ans)/next
  test∆printer lpr txt
next:
  html←utf8∆read test_data,'/manual.html'
  →(utl∆numberp ans←prompt 'This test will print a timothy''s manual.  Type OK <enter> for report ')/end
  →(~∧/'OK'=utl∆upper 2↑ans)/end
  test∆printer lpr∆html html
end:
  →0
nop:
  ⍞←'These tests cannot be performed without the printer name.'
  ans← prompt 'Do you want to try again?'
  →(utl∆numberp ans)/0
  →('Y'=utl∆upper 1↑ans)/top
  →0
∇
